<?php
/**
 * domains_domain plugin
 */


class domains_domain_plugin {

       var $plugin_name        = 'domains_domain_plugin';
       var $class_name         = 'domains_domain_plugin';

       /*
            This function is called when the plugin is loaded
    */
       function onLoad() {
               global $app;
               //Register for the events
               $app->plugin->registerEvent('domains:domain:on_after_insert', 'domains_domain_plugin', 'domains_domain_edit');
               $app->plugin->registerEvent('domains:domain:on_after_update', 'domains_domain_plugin', 'domains_domain_edit');
               syslog(6, 'ispconfig:' . __FILE__ . ':'.  __FUNCTION__ );
       }

       /*
               Function to ...
    */
       function domains_domain_edit($event_name, $page_form) {
	       global $app, $conf;

               syslog(6, 'ispconfig:' . __FILE__ . ':'.  __FUNCTION__ . ':' . __LINE__);

$this->oldDataRecord = &$page_form->oldDataRecord;
$this->dataRecord = &$page_form->dataRecord;

$a = $app->db->queryOneRecord("SELECT sys_groupid FROM domain WHERE domain = ?", $page_form->dataRecord['domain']);
$this->dataRecord["client_group_id"] = $a['sys_groupid'];


    // make sure that the record belongs to the client group and not the admin group when admin inserts it
    // also make sure that the user can not delete domain created by a admin
    if(isset($this->dataRecord["client_group_id"])) {
$app->load('tform_actions');
      $client_group_id = $app->functions->intval($this->dataRecord["client_group_id"]);

      $data = new tform_actions();
      $tform = $app->tform;
      $app->tform = new tform();

      $app->tform->loadFormDef("../dns/form/dns_soa.tform.php");
      $data->oldDataRecord = $app->db->queryOneRecord("SELECT * FROM dns_soa WHERE origin = ?", $this->dataRecord['domain'].".");
      if ($data->oldDataRecord) {
        $data->dataRecord = array_merge($data->oldDataRecord, array('client_group_id' => $this->dataRecord["client_group_id"]));
        $data->id = $data->dataRecord['id'];
        $app->plugin->raiseEvent("dns:dns_soa:on_after_update", $data);
      }

      $app->tform->loadFormDef("../dns/form/dns_slave.tform.php");
      $data->oldDataRecord = $app->db->queryOneRecord("SELECT * FROM dns_slave WHERE origin = ?", $this->dataRecord['domain'].".");
      if ($data->oldDataRecord) {
        $data->dataRecord = array_merge($data->oldDataRecord, array('client_group_id' => $this->dataRecord["client_group_id"]));
        $data->id = $data->dataRecord['id'];
        $app->plugin->raiseEvent("dns:dns_slave:on_after_update", $data);
      }
      $app->tform->loadFormDef("../mail/form/mail_domain.tform.php");
      $data->oldDataRecord = $app->db->queryOneRecord("SELECT * FROM mail_domain WHERE domain = ?", $this->dataRecord['domain']);
      if ($data->oldDataRecord) {
        $data->dataRecord = array_merge($data->oldDataRecord, array('client_group_id' => $this->dataRecord["client_group_id"]));
        $data->id = $data->dataRecord['domain_id'];
        $app->plugin->raiseEvent("mail:mail_domain:on_after_update", $data);
      }

      $app->tform->loadFormDef("../sites/form/web_vhost_domain.tform.php");
      $data->oldDataRecord = $app->db->queryOneRecord("SELECT * FROM web_domain WHERE domain = ?", $this->dataRecord['domain']);
      if ($data->oldDataRecord) {
        $data->dataRecord = array_merge($data->oldDataRecord, array('client_group_id' => $this->dataRecord["client_group_id"]));
        $data->id = $data->dataRecord['domain_id'];
        $app->plugin->raiseEvent("sites:web_vhost_domain:on_after_update", $data);
      }

      $app->tform = $tform;
    }
  }
}
